This demo shows how to use a Custom Codec to intercept JSON strings coming up from the target and create new properties that can be bound to the widgets in your GUI design.  The custom codec also shows how to encode these custom properties into whatever your target understands before sending the JSON string down to the target.

To start:
- plug in your MSP430F5529 Launchpad into the USB port of your PC
- hit F5 to refresh the browser and restart the auto-connection process. 
- Once the target has been downloaded, the LED status of the target device is reflected by the LED widgets, which are bound to the JSON string LEDs.Green and LEDs.Red.
- You can configure the status of the Green and Red LEDs using the droplist widget.  
  - The value of this widget is translated into the LEDs.Green and LEDs.Red format by the "Custom Codec" javascript file. 

To view / edit the custom codec file, open the [Gallery Tile for this app](https://dev.ti.com/gallery/info/21031/Tutorial_SerialIO_Custom_5529) and click on the ![designer icon](images/designerIcon.gif) icon to edit the app in the Designer.  Then click on the ![file folder icon](images/fileFolderIcon.gif)
icon in the Designer's toolbar, browse to the files inside the project and select the **custom_codec0.js** file.

To add a custom codec file to your own GUI Composer project:
- select File / New / Custom Codec from the Designer's menu to create the custom codec file and open it in the editor.
- **Important**: you *also* need to change the data format for your project's UART connection from JSON to Custom
    - select Project / Properties
    - click Next
    - click on the my_usb_uart item 
    - change the setting for the Protocol droplist to 'Custom'.

When running this demo in the Chrome browser, you can debug the application by: 
- hitting F12 
- selecting the Sources tab
- browsing to the app/custom_codec0.js file in the left pane of the debugger.  
- You can then set breakpoints and view the object contents using the Chrome Dev Tools debugger.

This demo requires the MSP430F5529.  For other devices:
- please download the [ControlLEDsJSON_Generic.ino](target/ControlLEDsJSON_Generic.ino) file 
- build this for your target device (e.g. using CCS Cloud). 
 - open this app in the GUI Composer Designer 
- change the target executable by:
   - selecting Project/Properties
   - clicking Next
   - clicking on the my_usb_uart item
   - changing the device name to match your device
   - uploading the target executable for your device.

To view this README.md file again, select Help / View README.md from the application's menu bar.
